#include        <mega16.h>
#include        "ind.h"
#include        "time1.h"
#include	"serv.h"
#include        "termD.h"
#include <delay.h>
#include        "mem_srv.h"
#include	"bud.h"

#asm
   .equ __w1_port=0x12 ;PORTD
   .equ __w1_bit=4
#endasm
#include <ds18b20.h>
                    
#define ADC_VREF_TYPE 0x40
                                       

unsigned int read_adc(unsigned char adc_input)
{
ADMUX=adc_input|ADC_VREF_TYPE;
ADCSRA|=0x40;
while ((ADCSRA & 0x10)==0);
ADCSRA|=0x10;
return ADCW;
}


#define MAX_DS1820 2
unsigned char ds1820_devices;
unsigned char ds1820_rom_codes[MAX_DS1820][9];
unsigned uDlBeep=0;

unsigned char uBud=0,ucCurBud=0;
unsigned char cBud[KOL_BUD1][3];
eeprom  unsigned char ucBud[KOL_BUD1][3]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
                                                //0 - 
                                                //1 - 
                                                //2 -   ()

eeprom   unsigned char   ucfSecMax=127;
eeprom  char            ds1820_rom_codes_e[MAX_DS1820][9];
eeprom  char            cIsTemp_e[2]={0,0};
flash   unsigned char   ucDayMon[12]={31,29,31,30,31,30,31,31,30,31,30,31};
eeprom  int     ieSaveStart=0,ieSaveStop=0; 
unsigned        char    str[2][40];                     // 
unsigned char cKeyBuff[16],cKeyStart=0,cKeyEnd=0;
float   fTerm[2]={-22.7,24.3};              
float   fPress=765;
unsigned uPress,uVl;
int iPress0=0;  
float   fVeter,fVl;
unsigned eeprom ueKVl=301;              // /10000
unsigned eeprom ueSVl=819;              // /1000
unsigned char ukVl=0;
unsigned uKVeter=1000;
int eeprom ueKPress=0;    
int uKPress;
float fKVl=.0301,fSVl=.819;
unsigned char cSecMax;
unsigned char cFlag=0;                  // 
                                        //1 -  
                                        //2 -  
                                        //4 -    
                                        //8 - 
                                        //0x10 -  
                                        //0x20 -  
                                        //0x40 -   
                                        //0x80 - 
unsigned char cOut[2]={1,2};            //   
                                        //0 - 
                                        //1 -    
                                        //2 -  -  -   
                                        //3 -   
                                        //4 -  
                                        //5
                                        //6
                                        //7
                                        
                                        //100 - 
                                        //101 - 
                                        //102 - 
                                        //103 - 
                                        //104 - 
                                        //105 -  
                                        //106 - 
                                        //107 - 
                                        //108 - 

signed char   ucTime[6];                      //ucSec,ucMin,ucHour,ucDay,ucDayN,ucMon;
unsigned        uYear;    
char            kKey=2;

int uHis;
unsigned char cHis[KOL_SAVE1];


unsigned       ucSaveStart=0,ucSaveStop=0;

unsigned char   ucPointStart=0,ucPointStop=0;
eeprom  unsigned char     iePointStart=0,iePointStop=0; 
eeprom  unsigned char ecPoint[KOL_SAVE2][5];
unsigned        uVeter0=0,uVeter=0;
#define RXB8 1
#define TXB8 0
#define UPE 2
#define OVR 3
#define FE 4
#define UDRE 5
#define RXC 7

#define FRAMING_ERROR (1<<FE)
#define PARITY_ERROR (1<<UPE)
#define DATA_OVERRUN (1<<OVR)
#define DATA_REGISTER_EMPTY (1<<UDRE)
#define RX_COMPLETE (1<<RXC)

void    Idle(void)
{
MCUCR&=0x0F; 
if(uDlBeep||(cFlag&6))
        MCUCR|=0b01000000;      //IDLE
else
        MCUCR|=0b11110000;      //sleep

#asm
sleep
#endasm    
MCUCR&=0b10111111;      //  
}


void    Tim0(void)
{
static unsigned char cTime=0,cKeyMax=10,cKeyOld=0xFF;
unsigned char ucOut,tmp,tmp1,i;

cTime++;   
if(PIND.3)                      //    USB
        cFlag|=4;
else
        cFlag&=~4;        
if(cTime<cKeyMax)
        return;
cTime=0;                
tmp=PORTC&0b11111000;
for(ucOut=1,i=0;i<3;ucOut<<=1,i++)
        {                                    
        PORTC=((~ucOut)&7)|tmp; 
        #asm("nop"); 
        #asm("nop"); 
        #asm("nop"); 
        tmp1=PIND&0b11000000;
        if(tmp1!=0b11000000)
                break;
        }                  
PORTC=tmp|7;                                        
if(i>=3)
        {               //No key
        cKeyMax=10;
        cKeyOld=0xFF;
        kKey=2;
        return;
        }       
tmp=i|(tmp1>>4);
if(tmp!=cKeyOld)
        {      
        cKeyOld=tmp;
        cKeyMax=10;
        kKey=2;
        return;
        }      
else
        cKeyMax=100;
if(!tmp)
        tmp=0x0f;
cKeyBuff[cKeyEnd]=tmp;
cFlag&=~2;                      //   
if(kKey)
        kKey--;
else
        cKeyMax=20;
cKeyEnd++;
if(cKeyEnd>15)
        cKeyEnd=0;
}


interrupt [EXT_INT0] void ext_int0_isr(void)
{
uVeter0++;
}

#define RX_BUFFER_SIZE 8
char rx_buffer[RX_BUFFER_SIZE];

#if RX_BUFFER_SIZE<256
unsigned char rx_wr_index,rx_rd_index,rx_counter;
#else
unsigned int rx_wr_index,rx_rd_index,rx_counter;
#endif

bit rx_buffer_overflow;

interrupt [USART_RXC] void usart_rx_isr(void)
{
char status,data;
status=UCSRA;
data=UDR;
if ((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0)
   {
   rx_buffer[rx_wr_index]=data;
   if (++rx_wr_index == RX_BUFFER_SIZE) rx_wr_index=0;
   if (++rx_counter == RX_BUFFER_SIZE)
      {
      rx_counter=0;
      rx_buffer_overflow=1;
      };
   };
}

#ifndef _DEBUG_TERMINAL_IO_
#define _ALTERNATE_GETCHAR_
#pragma used+
char getchar(void)
{
char data;
while (rx_counter==0);
data=rx_buffer[rx_rd_index];
if (++rx_rd_index == RX_BUFFER_SIZE) rx_rd_index=0;
#asm("cli")
--rx_counter;
#asm("sei")
return data;
}
#pragma used-
#endif

#define TX_BUFFER_SIZE 8
char tx_buffer[TX_BUFFER_SIZE];

#if TX_BUFFER_SIZE<256
unsigned char tx_wr_index,tx_rd_index,tx_counter;
#else
unsigned int tx_wr_index,tx_rd_index,tx_counter;
#endif

interrupt [USART_TXC] void usart_tx_isr(void)
{
if (tx_counter)
   {
   --tx_counter;
   UDR=tx_buffer[tx_rd_index];
   if (++tx_rd_index == TX_BUFFER_SIZE) tx_rd_index=0;
   };
}

#ifndef _DEBUG_TERMINAL_IO_
#define _ALTERNATE_PUTCHAR_
#pragma used+
void putchar(char c)
{
while (tx_counter == TX_BUFFER_SIZE);
#asm("cli")
if (tx_counter || ((UCSRA & DATA_REGISTER_EMPTY)==0))
   {
   tx_buffer[tx_wr_index]=c;
   if (++tx_wr_index == TX_BUFFER_SIZE) tx_wr_index=0;
   ++tx_counter;
   }
else
   UDR=c;
#asm("sei")
}
#pragma used-
#endif


interrupt [TIM2_OVF] void timer2_ovf_isr(void)
{
// Place your code here  
static unsigned char cTime=0,cTime1=0; 
static  unsigned char uDlBud=0;

Tim0();
cTime1++;
if(cTime1==128)
        {
        #asm("cli");
        cTime1=0;
        uVeter=uVeter0;
        uVeter0=0;
        #asm("sei");
        }
if(uDlBeep)
        {
        uDlBeep--;
        if(!uDlBeep)
                TCCR1A=0x80;    
        } 
else    if(cFlag&2)                 // 
        {
        if(uDlBud>=0x80)
                TCCR1A=0x80;    
        else
                TCCR1A=0x40;
        }
else
        TCCR1A=0x80;
cTime++;   
uDlBud++;
if(cTime>=cSecMax)
        {        
        cTime=0;
        IncSec();
        if(!(ucTime[0]%5))
                {
                IzmTemp();
                IzmPress();
                IzmVl();
                }
        
        OutInd(0);
        OutInd(1);
        }
     
}              

void main(void)
{
unsigned char tmp;
PORTA=0x00;
DDRA=0x0F;

PORTB=0x00;
DDRB=0x00;

PORTC=0x00;
DDRC=0x3F;

PORTD=0x08;
DDRD=0b00110011;

    
TCCR0=0x00;
TCNT0=0x00;
OCR0=0x00;

TCCR1A=0x80;
TCCR1B=0x0B;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x10;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

ASSR=0x08;
TCCR2=0x01;
TCNT2=0x00;
OCR2=0x00;


UCSRA=0x20;
UBRRH=0x00;
UBRRL=0x67;                  
UCSRB=0x98|0X40;
UCSRC=0x86;


GICR|=0x40;
MCUCR=0x02;
MCUCSR=0x00;
GIFR=0x40;

TIMSK=0b01000010;

ACSR=0x80;
SFIOR=0x00;

ADMUX=ADC_VREF_TYPE;
ADCSRA=0x87;            
SFIOR&=0x1F;

#pragma optsize-
WDTCR=0x1F;
WDTCR=0x0F;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif


MemInit();            //!!!!!!!!!!!!!!!!!!!!

FirstTime();
InitInd();                          


//    

fKVl=((float)ueKVl)/10000.,fSVl=((float)ueSVl)/1000.;
cSecMax=ucfSecMax;
uKPress=ueKPress;
ucSaveStart=ieSaveStart;
ucSaveStop=ieSaveStop;
ucPointStart=iePointStart;
ucPointStop=iePointStop;
LoadDS();
LoadBud();
#asm("sei");         

cFlag=1;       // 
           

TBeep(64,50,1);       
while (1)
      {               
      SaveInf();

      Idle();
        #asm("wdr");  
        
        
        while(rx_counter)
                {
                tmp=getchar();
                #asm("nop");
                #asm("nop");

                
                #asm("nop"); 
                SendInf(tmp);
                }
      tmp=GetKey();
      if(!tmp)
        continue;
      TBeep(64,8,kKey);
      switch(tmp)
        {
        case    0b1000:         //<-Up
        IncDecMenu(0,-1);
        break;
        
        case    0b1001:         //<-Down
        IncDecMenu(1,-1);
        break;
        
        case    0b1010:         //Control
        Control();
        break;
        
        case    0b0100:         //-> Up
        IncDecMenu(0,1);
        break;
        
        case    0b0101:         //->Down
        IncDecMenu(1,1);
        break;
        
        case    0x0F:         //      
        ControlBud();
        break;                                  
        
        case    1:              // 
        AddPoint();
        TBeep(120,10,kKey);
        break;
        
        default:                // 
        continue;
        }
      };
}
