
#include        <mega32.h>
#include        "ind.h"
#include        "time1.h"
#include	"serv.h"
#include        "termD.h"
#include <delay.h>
#include        "mem_srv.h"
#include	"bud.h"

#asm
   .equ __w1_port=0x12 ;PORTD
   .equ __w1_bit=4
#endasm
#include <ds18b20.h>
                    
#define ADC_VREF_TYPE 0x40
                                       

unsigned int read_adc(unsigned char adc_input)
{
ADMUX=adc_input|ADC_VREF_TYPE;
ADCSRA|=0x40;
while ((ADCSRA & 0x10)==0);
ADCSRA|=0x10;
return ADCW;
}


#define MAX_DS1820 2
unsigned char ds1820_devices;
unsigned char ds1820_rom_codes[MAX_DS1820][9];
unsigned uDlBeep=0;

unsigned char uBud=0,ucCurBud=0;
unsigned char cBud[KOL_BUD1][3];
eeprom  unsigned char ucBud[KOL_BUD1][3]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
                                                //0 - 
                                                //1 - 
                                                //2 -   ()

eeprom   unsigned char   ucfSecMax=127;
eeprom  char            ds1820_rom_codes_e[MAX_DS1820][9];
eeprom  char            cIsTemp_e[2]={0,0};
flash   unsigned char   ucDayMon[12]={31,29,31,30,31,30,31,31,30,31,30,31};
eeprom  int     ieSaveStart=0,ieSaveStop=0; 
unsigned        char    str[2][40];                     // 
unsigned char cKeyBuff[16],cKeyStart=0,cKeyEnd=0;
float   fTerm[2]={-22.7,24.3};              
float   fPress=765;
unsigned uPress,uVl;
int iPress0=0;  
float   fVeter,fVl;
unsigned eeprom ueKVl=301;              // /10000
unsigned eeprom ueSVl=819;              // /1000
unsigned char ukVl=0;
unsigned uKVeter=1000;
int eeprom ueKPress=0;    
int uKPress;
float fKVl=.0301,fSVl=.819;
unsigned char cSecMax;
unsigned char cFlag=0;                  // 
                                        //1 -  
                                        //2 -  
                                        //4 -    
                                        //8 - 
                                        //0x10 -  
                                        //0x20 -  
                                        //0x40 -   
                                        //0x80 - 
unsigned char cOut[2]={1,2};            //   
                                        //0 - 
                                        //1 -    
                                        //2 -  -  -   
                                        //3 -   
                                        //4 -  
                                        //5
                                        //6
                                        //7
                                        
                                        //100 - 
                                        //101 - 
                                        //102 - 
                                        //103 - 
                                        //104 - 
                                        //105 -  
                                        //106 - 
                                        //107 - 
                                        //108 - 

signed char   ucTime[6];                      //ucSec,ucMin,ucHour,ucDay,ucDayN,ucMon;
unsigned        uYear;    
char            kKey=2;

int uHis;
unsigned char cHis[KOL_SAVE1];


unsigned       ucSaveStart=0,ucSaveStop=0;

unsigned char   ucPointStart=0,ucPointStop=0;
eeprom  unsigned char     iePointStart=0,iePointStop=0; 
eeprom  unsigned char ecPoint[KOL_SAVE2][5];
//eeprom struct SaveStr  sS[MAX_SAVE];
//unsigned ucKolSave=0;
unsigned        uVeter0=0,uVeter=0;
#define RXB8 1
#define TXB8 0
#define UPE 2
#define OVR 3
#define FE 4
#define UDRE 5
#define RXC 7

#define FRAMING_ERROR (1<<FE)
#define PARITY_ERROR (1<<UPE)
#define DATA_OVERRUN (1<<OVR)
#define DATA_REGISTER_EMPTY (1<<UDRE)
#define RX_COMPLETE (1<<RXC)

void    Idle(void)
{
MCUCR&=0x0F; 
if(uDlBeep||(cFlag&6))
        MCUCR|=0b01000000;      //IDLE
else
        MCUCR|=0b11110000;      //sleep

#asm
sleep
#endasm    
MCUCR&=0b10111111;      //  
}


void    Tim0(void)
{
static unsigned char cTime=0,cKeyMax=10,cKeyOld=0xFF;
unsigned char ucOut,tmp,tmp1,i;

cTime++;   
if(PIND.3)                      //    USB
        cFlag|=4;
else
        cFlag&=~4;        
if(cTime<cKeyMax)
        return;
cTime=0;                
tmp=PORTC&0b11111000;
for(ucOut=1,i=0;i<3;ucOut<<=1,i++)
        {                                    
        PORTC=((~ucOut)&7)|tmp; 
        #asm("nop"); 
        #asm("nop"); 
        #asm("nop"); 
        tmp1=PIND&0b11000000;
        if(tmp1!=0b11000000)
                break;
        }                  
PORTC=tmp|7;                                        
if(i>=3)
        {               //No key
        cKeyMax=10;
        cKeyOld=0xFF;
        kKey=2;
        return;
        }       
tmp=i|(tmp1>>4);
if(tmp!=cKeyOld)
        {      
        cKeyOld=tmp;
        cKeyMax=10;
        kKey=2;
        return;
        }      
else
        cKeyMax=100;
if(!tmp)
        tmp=0x0f;
cKeyBuff[cKeyEnd]=tmp;
cFlag&=~2;                      //   
if(kKey)
        kKey--;
else
        cKeyMax=20;
cKeyEnd++;
if(cKeyEnd>15)
        cKeyEnd=0;
}


interrupt [EXT_INT0] void ext_int0_isr(void)
{
uVeter0++;
}

#define RX_BUFFER_SIZE 8
char rx_buffer[RX_BUFFER_SIZE];

#if RX_BUFFER_SIZE<256
unsigned char rx_wr_index,rx_rd_index,rx_counter;
#else
unsigned int rx_wr_index,rx_rd_index,rx_counter;
#endif

bit rx_buffer_overflow;

interrupt [USART_RXC] void usart_rx_isr(void)
{
char status,data;
status=UCSRA;
data=UDR;
if ((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0)
   {
   rx_buffer[rx_wr_index]=data;
   if (++rx_wr_index == RX_BUFFER_SIZE) rx_wr_index=0;
   if (++rx_counter == RX_BUFFER_SIZE)
      {
      rx_counter=0;
      rx_buffer_overflow=1;
      };
   };
}

#ifndef _DEBUG_TERMINAL_IO_
#define _ALTERNATE_GETCHAR_
#pragma used+
char getchar(void)
{
char data;
while (rx_counter==0);
data=rx_buffer[rx_rd_index];
if (++rx_rd_index == RX_BUFFER_SIZE) rx_rd_index=0;
#asm("cli")
--rx_counter;
#asm("sei")
return data;
}
#pragma used-
#endif

#define TX_BUFFER_SIZE 8
char tx_buffer[TX_BUFFER_SIZE];

#if TX_BUFFER_SIZE<256
unsigned char tx_wr_index,tx_rd_index,tx_counter;
#else
unsigned int tx_wr_index,tx_rd_index,tx_counter;
#endif

interrupt [USART_TXC] void usart_tx_isr(void)
{
if (tx_counter)
   {
   --tx_counter;
   UDR=tx_buffer[tx_rd_index];
   if (++tx_rd_index == TX_BUFFER_SIZE) tx_rd_index=0;
   };
}

#ifndef _DEBUG_TERMINAL_IO_
#define _ALTERNATE_PUTCHAR_
#pragma used+
void putchar(char c)
{
while (tx_counter == TX_BUFFER_SIZE);
#asm("cli")
if (tx_counter || ((UCSRA & DATA_REGISTER_EMPTY)==0))
   {
   tx_buffer[tx_wr_index]=c;
   if (++tx_wr_index == TX_BUFFER_SIZE) tx_wr_index=0;
   ++tx_counter;
   }
else
   UDR=c;
#asm("sei")
}
#pragma used-
#endif

interrupt [TIM2_OVF] void timer2_ovf_isr(void)
{
static unsigned char cTime=0,cTime1=0; 
static  unsigned char uDlBud=0;

Tim0();
cTime1++;
if(cTime1==128)
        {
        #asm("cli");
        cTime1=0;
        uVeter=uVeter0;
        uVeter0=0;
        #asm("sei");
        }
if(uDlBeep)
        {
        uDlBeep--;
        if(!uDlBeep)
                TCCR1A=0x80;    
        } 
else    if(cFlag&2)                 // 
        {
        if(uDlBud>=0x80)
                TCCR1A=0x80;    
        else
                TCCR1A=0x40;
        }
else
        TCCR1A=0x80;
cTime++;   
uDlBud++;
if(cTime>=cSecMax)
        {        
        cTime=0;
        IncSec();
        if(!(ucTime[0]%5))
                {
                IzmTemp();
                IzmPress();
                IzmVl();
                }
        
        OutInd(0);
        OutInd(1);
        }
     
}              

void main(void)
{
unsigned char tmp;
PORTA=0x00;
DDRA=0x0F;

PORTB=0x00;
DDRB=0x00;

PORTC=0x00;
DDRC=0x3F;

PORTD=0x08;
DDRD=0b00110011;
 
TCCR0=0x00;
TCNT0=0x00;
OCR0=0x00;

TCCR1A=0x80;
TCCR1B=0x0B;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x10;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

ASSR=0x08;
TCCR2=0x01;
TCNT2=0x00;
OCR2=0x00;

UCSRA=0x20;
UBRRH=0x00;
UBRRL=0x67;                  
UCSRB=0x98|0X40;
UCSRC=0x86;

GICR|=0x40;
MCUCR=0x02;
MCUCSR=0x00;
GIFR=0x40;

TIMSK=0b01000010;

ACSR=0x80;
SFIOR=0x00;

ADMUX=ADC_VREF_TYPE;
ADCSRA=0x87;            
SFIOR&=0x1F;

#pragma optsize-
WDTCR=0x1F;
WDTCR=0x0F;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif


MemInit();            //!!!!!!!!!!!!!!!!!!!!

FirstTime();
InitInd();                          


//    
fKVl=((float)ueKVl)/10000.,fSVl=((float)ueSVl)/1000.;
cSecMax=ucfSecMax;
uKPress=ueKPress;
ucSaveStart=ieSaveStart;
ucSaveStop=ieSaveStop;
ucPointStart=iePointStart;
ucPointStop=iePointStop;
LoadDS();
LoadBud();
#asm("sei");         

cFlag=1;       // 
           
TBeep(64,50,1);       
while (1)
      {               
      SaveInf();

      Idle();
        #asm("wdr");  
        
        
        while(rx_counter)
                {
                tmp=getchar();
                #asm("nop");
                #asm("nop");
                #asm("nop"); 
                SendInf(tmp);
                }
      tmp=GetKey();
      if(!tmp)
        continue;
      TBeep(64,8,kKey);
      switch(tmp)
        {
        case    0b1000:         //<-Up
        IncDecMenu(0,-1);
        break;
        
        case    0b1001:         //<-Down
        IncDecMenu(1,-1);
        break;
        
        case    0b1010:         //Control
        Control();
        break;
        
        case    0b0100:         //-> Up
        IncDecMenu(0,1);
        break;
        
        case    0b0101:         //->Down
        IncDecMenu(1,1);
        break;
        
        case    0x0F:         //      
        ControlBud();
        break;                                  
        
        case    1:              // 
        AddPoint();
        TBeep(120,10,kKey);
        break;
        
        default:                // 
        continue;
        }
      };
}
#include        "ind.h"
#include        <delay.h>

extern unsigned        char    str[2][40];                     // 


/* [0] "  " */
flash char Init0[]={32,32,77,101,191,101,111,99,191,97,189,229,184,199,0};

/* [0] "   " */
flash char Init1[]={32,32,32,32,32,32,171,97,99,195,0};

/* [0] "" */
flash char Init2[]={32,32,80,97,183,112,97,178,111,191,97,187,0};

/* [0] "." */
flash char Init3[]={32,32,65,46,164,121,185,186,111,179,0};

/* [0] "." */  
flash unsigned char Init4[]={32,32,165,46,75,179,97,99,111,179,0};

  
unsigned char RDCom8(void)
{      
unsigned char tmp;

#asm
sbi     0x15,4              // PORTC,5 (RW) - !
cbi     0x15,3              // PORTC,6 (RS) - !
nop
nop
nop  
nop
nop
nop  
sbi     0x15,5          //PORTC,5(E)
nop
nop
nop  
nop
nop
nop
#endasm
tmp=PINA&0x0f;
#asm
nop
nop
nop  
nop
nop
nop  
cbi     0x15,5          //PORTC,5(E)
cbi     0x15,4              // PORTC,5 (RW) - !
#endasm
return tmp;
}


void    WRCom8(unsigned char c)
{                            
#asm
cbi     0x15,4              // PORTC,5 (RW) - !
cbi     0x15,3              // PORTC,6 (RS) - !
nop
nop
nop  
nop
nop
nop  
#endasm
DDRA=0x0f;                  //   
c>>=4;
PORTA=c;   
#asm
sbi     0x15,5          //PORTC,5(E)
nop
nop
nop
nop
nop  
nop
cbi     0x15,5
#endasm
DDRA=0x0;                  //8    
PORTA=0;
}

unsigned char RDCom4(void)
{
unsigned char tmp,tmp1;

#asm
sbi     0x15,4              // PORTC,5 (RW) - !
cbi     0x15,3              // PORTC,6 (RS) - !
nop
nop
nop
nop  
nop
nop  
sbi     0x15,5          //PORTC,5(E)
nop
nop
nop
nop  
nop
nop
#endasm
tmp=PINA&0x0f;
tmp=PINA&0x0f;
#asm
cbi     0x15,5          //PORTC,5(E)  
nop
nop
nop
nop  
nop
nop  
sbi     0x15,5          //PORTC,5(E)
nop
nop
nop
nop
nop  
nop  
#endasm
tmp1=PINA&0x0f;
tmp1=PINA&0x0f;
#asm
cbi     0x15,5          //PORTC,5(E)  
cbi     0x15,4              // PORTC,5 (RW) - !
#endasm
return (tmp<<4)|tmp1;
}

void    WhiteBisiy(void)
{
while(1)
        {
        if(!(RDCom4()&0x80))
                break;
        #asm("wdr");
        }
}

void    WR4(unsigned char cKom,unsigned char c)
{                                           

WhiteBisiy();
if(cKom)                                ///
        {
        #asm("sbi     0x15,3");                                             
        }

else    
        {
        #asm("cbi     0x15,3");    
        }
DDRA=0x0f;                  //  
PORTA=(c>>4);
#asm
sbi     0x15,5          //PORTC,5(E)
nop
nop
nop
nop
nop  
nop  
nop
nop
nop  
cbi     0x15,5          //PORTC,5(E)
nop
nop
nop
nop
nop  
nop  
nop
nop
nop  
#endasm
PORTA=(c&0x0f);
#asm
sbi     0x15,5          //PORTC,5(E)
nop
nop
nop
nop
nop  
nop  
cbi     0x15,5          //PORTC,5(E)
#endasm
                                         
DDRA=0x0;                  //8    
PORTA=0x0;
}

void    CopyStrFlash(unsigned char n,flash unsigned char *s)
{
unsigned char   *b;
unsigned char   i,j;

if(n)
        n=1;
b=str[n];
for(i=j=0;i<16;i++)
        {       
        if(s[j])
                *b=s[j],j++;
        else
                *b=' ';
        b++;
        }
}

void    OutStr(unsigned char n)
{                                                  
unsigned char   *b,i;

if(n)                           // 
        WR4(0,0xC0),n=1;
else
        WR4(0,0x80);
b=str[n];
i=0;
while(*b)
        {         
                WR4(1,*b);
                b++;
        }
}


void    InitInd(void)
{            
#asm("wdr");
delay_ms(20);
#asm("wdr");
WRCom8(0x30);
delay_us(4100);
#asm("wdr");
WRCom8(0x30);
delay_us(100);
WRCom8(0x30); 
#asm("wdr");
while(1)
        {
        if(!(RDCom8()&0x8))
                break;
        #asm("wdr");
        }   
WRCom8(0x20);   // 4-  ;
WR4(0,0x28);    //2 , 4 
WR4(0,0x0c);    //                         
WR4(0,0x06);    //   
CopyStrFlash(0,Init0);
CopyStrFlash(1,Init1); 

OutStr(0);
OutStr(1);
delay_ms(2000);            //2000
#asm("wdr");
CopyStrFlash(0,Init2);
OutStr(0);
CopyStrFlash(1,Init4);
OutStr(1);
delay_ms(2000);         
#asm("wdr");
CopyStrFlash(1,Init3);
OutStr(1);
delay_ms(2000);         
#asm("wdr");

}

#include        "time1.h"
#include        "termD.h"


extern signed char   ucTime[6];                       //ucSec,ucMin,ucHour,ucDay,ucDayN,ucMon;
extern unsigned        uYear;
extern flash unsigned char ucDayMon[12];
extern  unsigned char cSecMax;
extern int uKPress;

char    IsVis(void)
{
    if (!(uYear%100))
        return (uYear%400)?0:1;
    else
        return (uYear%4)?0:1;
}

char    NewMon(void)
{        
char tmp;

if(ucTime[5]!=1)
        {                       // 
        if(ucTime[3]>ucDayMon[ucTime[5]])
                return 1;
        else
                return 0;
        }                
else
        {
        tmp=28;
        if(IsVis())
                tmp++;
        if(ucTime[3]>=tmp)
                return 1;
        else
                return 0;
        }
}
      
void    IncDecTime(unsigned char ucKto,signed char PM)
{     
ucKto-=101;         
switch(ucKto)
        {
        case    6:            //
        uYear+=PM;
        return;

        case    7:            //
        cSecMax+=PM;
        ucfSecMax=cSecMax;
        return;

        case    9:            //
        uKPress+=PM;
        ueKPress=uKPress;
        return;


        case    10:            //
        uKVeter+=PM;
        return;


        case    11:            //
        ueSVl+=PM;
        return;
        case    12:            //
        ueKVl+=PM;
        return;

        case    0:          //sec
        case    1:          //min
        ucTime[ucKto]+=PM;
        if(ucTime[ucKto]>=60)
                ucTime[ucKto]=0;
        if(ucTime[ucKto]<0)
                ucTime[ucKto]=59;
        return;
        
        case    2:            //
        ucTime[ucKto]+=PM;
        if(ucTime[ucKto]>=24)
                ucTime[ucKto]=0;
        if(ucTime[ucKto]<0)
                ucTime[ucKto]=23;
        return;

        case    3:            //
        ucTime[ucKto]+=PM;
        if(ucTime[ucKto]>ucDayMon[ucTime[106-101]])
                ucTime[ucKto]=1;
        if(ucTime[ucKto]<1)
                ucTime[ucKto]=ucDayMon[ucTime[106-101]];
        
        return;

        case    4:            // 
        ucTime[ucKto]+=PM;
        if(ucTime[ucKto]>=7)
                ucTime[ucKto]=0;
        if(ucTime[ucKto]<0)
                ucTime[ucKto]=6;
        return;

        case    5:            // 
        ucTime[ucKto]+=PM;
        if(ucTime[ucKto]>=12)
                ucTime[ucKto]=0;
        if(ucTime[ucKto]<0)
                ucTime[ucKto]=11;
        return;   
        
        case    8:              // 
        ObmenDS();
        return;

        case    13:              // 
        FindTemp();
        SaveDS();
        return;

        case    14:              ///   
        cFlag^=4;
        return;
        }
}

void   FirstTime(void)
{                            
ucTime[0]=0;
ucTime[1]=0;
ucTime[2]=0;
ucTime[3]=1;
ucTime[4]=0;
ucTime[5]=0;
uYear=2005;
}


void   IncSec(void)
{     
ucTime[0]++;


if(ucTime[0]>=60)
        {
        ucTime[1]++;
        ucTime[0]=0;
        TstBud();

        if(ucTime[1]>=60)
                {
                ucTime[2]++;
                ucTime[1]=0;                  
                cFlag|=0x40;

                if(ucTime[2]>=24)
                        {
                        ucTime[2]=0;
                        ucTime[3]++;
                        ucTime[4]++;
                        if(ucTime[4]>=7)
                                ucTime[4]=0;
                        if(NewMon())
                                {
                                ucTime[3]=1;
                                ucTime[5]++;
                                if(ucTime[5]>=12)
                                        {
                                        ucTime[5]=0;
                                        uYear++;
                                        }
                                }
                        }
                }
        }   
 }         
 
 
 long    DT(signed char d1,signed char m1,int y1)
 {
 long   l=0;                                    
 int    i=2001;  
 signed char m=0;
               
 while(i<y1)
        {
        l+=365;
        if(!(i%4))
                l++;
        i++;
        }       
 while(m<m1)
        {
        l+=ucDayMon[m];
        if((!(i%4))&&(m==1))
                l--;
        m++;
        }          
 l+=d1;
 return l;
 }     
 
signed char FL(signed char d1,signed char m1,int y1)
{
long    j;
float   dd,d;
signed char i;

j=DT(d1,m1,y1); 

dd=0.20439731+j*0.03386319269+j*j*0.0301e-14;
d=dd-((long)dd);
if(d>0.5)
        d=1-d,i=-20;
else
        i=20;
return d*i;
}
#include	"serv.h"
#include	"time1.h"
#include	"ind.h"
#include        "mem_srv.h"
#include        "bud.h"

extern unsigned char   ucPointStart,ucPointStop;
extern eeprom  unsigned char     iePointStart,iePointStop; 
extern eeprom  unsigned char ecPoint[KOL_SAVE2][5];

extern float   fTerm[2];              
extern float   fPress,fVl;
extern unsigned uPress,uVl;
extern int iPress0;    
extern int uKPress;
extern float fKVl,fSVl;
extern unsigned char ukVl;

extern eeprom unsigned char ucSave[MAX_SAVE];
extern unsigned       ucSaveStart,ucSaveStop;
extern eeprom  int     ieSaveStart,ieSaveStop; 

flash unsigned char ucVersion[]=", , ,  2.05";

/* [0] "" */
flash unsigned char sPress[]={224,97,179,187,101,189,184,101,0};
/* [0] "" */
flash unsigned char sVeter[]={66,101,191,101,112,0};
/* [0] "" */
flash unsigned char sVl[]={66,187,97,182,189,111,99,191,196,0};

/* [0] " " */  
flash unsigned char sFL[]={228,97,183,97,32,187,121,189,195,0};



/* [0] " " */  flash unsigned char smTemp0[]={72,97,32,121,187,184,229,101,0};
/* [1] ""     */  flash unsigned char smTemp1[]={224,111,188,97,0};
flash unsigned char *sTemp[2];
                 

/* [0] "" */  flash unsigned char smDN0[]={168,111,189,101,227,0};
/* [1] "" */  flash unsigned char smDN1[]={66,191,111,112,189,0};
/* [2] "" */  flash unsigned char smDN2[]={67,112,101,227,97,0};
/* [3] ""  */  flash unsigned char smDN3[]={171,101,191,179,0};
/* [4] ""  */  flash unsigned char smDN4[]={168,199,191,189,0};
/* [5] ""  */  flash unsigned char smDN5[]={67,121,178,178,0};
/* [6] "" */  flash unsigned char smDN6[]={66,111,99,186,112,0};

flash unsigned char *sDN[7];


/* [0] ""   */  flash unsigned char smMon0[]={177,189,179,97,112,196,0};
/* [1] ""  */  flash unsigned char smMon1[]={228,101,179,112,97,187,196,0};
/* [2] ""     */  flash unsigned char smMon2[]={77,97,112,191,0};
/* [3] ""   */  flash unsigned char smMon3[]={65,190,112,101,187,196,0};
/* [4] ""      */  flash unsigned char smMon4[]={77,97,185,0};
/* [5] ""     */  flash unsigned char smMon5[]={165,198,189,196,0};
/* [6] ""     */  flash unsigned char smMon6[]={165,198,187,196,0};
/* [7] ""   */  flash unsigned char smMon7[]={65,179,180,121,99,191,0};
/* [8] "" */  flash unsigned char smMon8[]={67,101,189,191,199,178,112,196,0};
/* [9] ""  */  flash unsigned char smMon9[]={79,186,191,199,178,112,196,0};
/* [10] ""   */  flash unsigned char smMon10[]={72,111,199,178,112,196,0};
/* [11] ""  */  flash unsigned char smMon11[]={224,101,186,97,178,112,196,0};

flash unsigned char *sMon[12];


/* [0] " ." */  flash unsigned char sNastr[]={72,97,99,191,112,111,185,186,97,32,190,97,112,97,188,46,0};

/* [0] ""   */  flash unsigned char smParNastr0[]={67,101,186,121,189,227,195,0};
/* [1] ""    */  flash unsigned char smParNastr1[]={77,184,189,121,191,195,0};
/* [2] ""      */  flash unsigned char smParNastr2[]={171,97,99,195,0};
/* [3] ""      */  flash unsigned char smParNastr3[]={224,101,189,196,0};
/* [4] " "  */  flash unsigned char smParNastr4[]={224,101,189,196,32,189,101,227,0};
/* [5] ""     */  flash unsigned char smParNastr5[]={77,101,99,199,229,0};
/* [6] ""       */  flash unsigned char smParNastr6[]={161,111,227,0};
/* [7] "" */  flash unsigned char smParNastr7[]={75,111,112,112,101,186,229,184,199,0};
/* [8] ""     */  flash unsigned char smParNastr8[]={79,178,188,101,189,0};
/* [9] " " */  flash unsigned char smParNastr9[]={168,111,184,99,186,32,227,97,191,192,184,186,111,179,0};
/* [10] "" */  flash unsigned char smParNastr10[]={67,179,199,183,196,0};

/* [0] "" */  flash unsigned char smBud0[]={160,121,227,184,187,196,189,184,186,0};
/* [1] ""   */  flash unsigned char smBud1[]={168,66,67,171,168,67,66,0};
/* [2] ""   */  flash unsigned char smBud2[]={190,179,99,192,190,99,179,0};
                                                                                   

extern int uHis;
extern unsigned char cHis[KOL_SAVE1];

flash unsigned char *sParNastr[11];

extern flash unsigned char ucDayMon[12];
extern unsigned char cFlag;                   // 
                                                //1 -  ;
extern unsigned char *cOut;           
extern unsigned        char    str[2][40];                     // 
extern signed char   ucTime[6];               //ucSec,ucMin,ucHour,ucDay,ucDayN,ucMon;
extern unsigned        uYear;
extern float fVeter;         
extern unsigned uVeter,uKVeter;
extern unsigned char cKeyBuff[16],cKeyStart,cKeyEnd;

signed char    FtoChar(float f)
{
signed char    c,i;

c=f;
i=0;
if(f<0)
        {
        c=-c;
        f=-f;
        i=1;
        }   
f-=c;
if(f>=.5)
        c++;
if(i)
        c=-c;
return c;
}

unsigned char    FtoUChar(float f)
{
unsigned char    c;

c=f;
f-=c;
if(f>=.5)
        c++;
return c;
}

void    TBeep(unsigned uF,unsigned uDl,char kK)
{  
if(!kK)
        return;         
OCR1A=uF;
uDlBeep=uDl;
TCCR1A=0x40;
}

unsigned char GetKey(void)
{                    
unsigned char tmp;

if(cKeyStart==cKeyEnd)
        return 0;
tmp=cKeyBuff[cKeyStart++];
if(cKeyStart>15)
        cKeyStart=0;
return tmp;

}

void    UCToStr(unsigned char *b,unsigned char c)
{
*(b++)='0'+c/10;
*(b++)='0'+c%10;
}           

void    UToStr(unsigned char *b,unsigned u)
{
*(b++)='0'+u/1000;
u%=1000;
*(b++)='0'+u/100;
u%=100;
*(b++)='0'+u/10;
*(b++)='0'+u%10;
}

void    FToStr(unsigned char *b,float f,unsigned char n)
{                     
unsigned tmp,i;

if(f<0)
        {
        *(b++)='-';
        f=0-f;
        }   
else
        *(b++)=' ';
if(f>100)
        {
        *(b++)='E';
        *(b++)='r';
        *(b++)='r';
        return;
        }       
tmp=f/10;
if(tmp)
        *(b++)='0'+tmp;
else
        *(b++)=' ';
f=f-tmp*10;
tmp=f;
*(b++)='0'+tmp;
f=f-tmp;
*(b++)='.';
for(i=0;i<n;i++)
        {
        f*=10;
        tmp=f;
        *(b++)='0'+tmp;
        f=f-tmp;
        }
}

void    FToStr1(unsigned char *b,float f)
{                     
unsigned tmp;

tmp=f/100;
*(b++)='0'+tmp;
f=f-tmp*100;
tmp=f/10;
*(b++)='0'+tmp;
f=f-tmp*10;
tmp=f;
*(b++)='0'+tmp;
f=f-tmp;
*(b++)='.';
        f*=10;
        tmp=f;
        *(b++)='0'+tmp;
        f=f-tmp;
}
                          
void    LoadHis(void)
{
unsigned char j; 
int     u;          
          
u=ucSaveStart+uHis+1;
if(u>=(MAX_SAVE))
        u-=MAX_SAVE;
for(j=0;j<KOL_SAVE1;j++)
        ReadMemoryByte(u,j,cHis+j);
}

void    ShowZap(void)
{
unsigned char   uc=1,tmp;
int             uKolSave;                                                  
                         
uKolSave=ucSaveStop-ucSaveStart;
if(uKolSave<0)
        uKolSave+=MAX_SAVE;
if(!uKolSave)
        return;
uHis=uKolSave-1;         
LoadHis();
cOut[0]=200;                    // -    
cOut[1]=201;                    // 
while(9)
        {
        #asm("WDR"); 
        if(uc)
                {
                uc=0;
                OutInd(1);
                OutInd(0);
                } 
        SaveInf();  
        Idle();
        while(rx_counter)
                {
                tmp=getchar();
                #asm("nop");
                #asm("nop");
                #asm("nop"); 
                SendInf(tmp);
                }
        tmp=GetKey();
        if(!tmp)        
                continue;
        TBeep(64,8,kKey);
        switch(tmp)
                {       
                case    0b1001:         //<-Up             
                cOut[1]--;
                if(cOut[1]<=200)
                        cOut[1]=206;
                uc=1;
                continue;                                 
        
                case    0b1000:         //<-Down
                uHis--;
                if(uHis<0)
                        {
                        uHis=0;
                        TBeep(164,8,kKey);
                        }
                else
                        {
                        LoadHis();
                        uc=1; 
                        }
                continue;                                 
        
                case    0b1010:         //Control
                break;
        
                case    0b0101:         //-> Up    (+1)
                cOut[1]++;
                if(cOut[1]>206)
                        cOut[1]=201;
                uc=1;
                continue;                                 
        
                case    0b0100:         //->Down    (-1)
                uHis++;
                if(uHis>=uKolSave)
                        {
                        uHis--;
                        TBeep(164,8,kKey);
                        }
                else
                        {
                        LoadHis();
                        uc=1;
                        }
                continue;                                 
        
                default:                // 
                continue;
                }
        break;
        }
         
}


void    Control(void)
{
unsigned char   uc=1,tmp;                                                  
unsigned char cOutOld[2];

//cFlag|=2;                
cOutOld[0]=cOut[0];
cOutOld[1]=cOut[1];

cOut[0]=100;                    // ""
OutInd(0);
cOut[1]=101;                    //
while(9)
        {
        #asm("WDR"); 
        if(uc)
                {
                uc=0;
                OutInd(1);
                } 
        SaveInf();  
        Idle();
        while(rx_counter)
                {
                tmp=getchar();
                #asm("nop");
                #asm("nop");
                #asm("nop"); 
                SendInf(tmp);
                }
        tmp=GetKey();
        if(!tmp)        
                continue;
        TBeep(64,8,kKey);
        switch(tmp)
                {       
                case    0b1000:         //<-Up             
                cOut[1]--;
                if(cOut[1]<=100)
                        cOut[1]=115;
                uc=1;
                continue;                                 
        
                case    0b1001:         //<-Down
                IncDecTime(cOut[1],-1);
                uc=1;
                continue;                                 
        
                case    0b1010:         //Control
                ueKPress=uKPress;
                ShowZap();
                break;
        
                case    0b0100:         //-> Up    (+1)
                cOut[1]++;
                if(cOut[1]>115)
                        cOut[1]=101;
                uc=1;
                continue;                                 
        
                case    0b0101:         //->Down    (-1)
                IncDecTime(cOut[1],1);
                uc=1;
                continue;                                 
        
                default:                // 
                continue;
                }
        break;
        }
         
cOut[0]=cOutOld[0];
cOut[1]=cOutOld[1];
OutInd(0);
OutInd(1);
}

void    IncDecMenu(unsigned char ucStr,signed char u)
{           
if(ucStr>1)
        return;
cOut[ucStr]+=u;
if(cOut[ucStr]<1)
        cOut[ucStr]=8;
if(cOut[ucStr]>8)
        cOut[ucStr]=1;
OutInd(ucStr);
}

void	OutInd(unsigned char cStrNum)
{
unsigned char *b,i=0,j,b1;
unsigned char   tmp;          
static char c=1; 
signed char cFL;        
float   f;
               
if(c)
        {
        c=0;
        sTemp[0]=smTemp0;
        sTemp[1]=smTemp1;
        sDN[0]=smDN0;
        sDN[1]=smDN1;
        sDN[2]=smDN2;
        sDN[3]=smDN3;
        sDN[4]=smDN4;
        sDN[5]=smDN5;
        sDN[6]=smDN6;
        sMon[0]=smMon0;
        sMon[1]=smMon1;
        sMon[2]=smMon2;
        sMon[3]=smMon3;
        sMon[4]=smMon4;
        sMon[5]=smMon5;
        sMon[6]=smMon6;
        sMon[7]=smMon7;
        sMon[8]=smMon8;
        sMon[9]=smMon9;
        sMon[10]=smMon10;
        sMon[11]=smMon11;     
        sParNastr[0]=smParNastr0;
        sParNastr[1]=smParNastr1;
        sParNastr[2]=smParNastr2;
        sParNastr[3]=smParNastr3;
        sParNastr[4]=smParNastr4;
        sParNastr[5]=smParNastr5;
        sParNastr[6]=smParNastr6;
        sParNastr[7]=smParNastr7;
        sParNastr[8]=smParNastr8;
        sParNastr[9]=smParNastr9;
        sParNastr[10]=smParNastr10;
        }
if(!(cFlag&1))
        return;
fPress=(((float)uPress)/1024.+.095)*833.4018697+uKPress;
fVeter=(float)uVeter*uKVeter/10000.;
f=fVl*ukVl;
ukVl++;
f+=(((float)uVl)*.004883-fSVl)/fKVl;
fVl=f/ukVl;
if(ukVl>100)
        ukVl=100;


if(cStrNum>1)
        return;  
b=str[cStrNum];                             
switch(tmp=cOut[cStrNum])
        {
        case    0:                              // 
        break;
        
        case    1:                              //  
        UCToStr(b,ucTime[2]);
        b+=2;
        *(b++)=':';
        UCToStr(b,ucTime[1]);
        b+=2;
        *(b++)=':';
        UCToStr(b,ucTime[0]);
        b+=2;
        *(b++)=' ';
        i=8;          
        for(j=0;i<16;i++,j++)
                {
                b1=sDN[ucTime[4]][j];
                if(!b1)
                        break;
                *(b++)=b1;
                }
        for(;i<16;i++)
                {      
                *(b++)=' ';
                }
        break;
        
        case    2:                              //
        UCToStr(b,ucTime[3]);
        b+=2;
        *(b++)=' ';
        i=2;
        for(j=0;i<16;i++,j++)
                {
                b1=sMon[ucTime[5]][j];
                if(!b1)
                        break;
                *(b++)=b1;
                }            
        *(b++)=' ';
        i++;   
        UToStr(b,uYear);
        b+=4;
        i+=4;
        for(;i<16;i++)
                {      
                *(b++)=' ';
                }
        break;

        case    3:
        case    4:
        case    201:
        case    202:
                                        //3 -   
                                        //4 -  
        CopyStrFlash(cStrNum,sTemp[tmp-(tmp<200?3:201)]);
        b+=10; 
        if(tmp<200)
                FToStr(b,fTerm[tmp-3],1);
        else
                FToStr(b,(signed char)cHis[tmp-197],1);
        b[5]='C';
        break;
                           
        case    5:                      //
        case    110:
        case    203:
        CopyStrFlash(cStrNum,sPress);
        b+=8;                        
        if(tmp<200)
                UToStr(b,fPress);
        else
                UToStr(b,700+cHis[6]);
        *b=' ';
        b[5]='m';
        b[6]='m';
        break;             

        case    6:                      //
        case    111:             
        case    205:
        CopyStrFlash(cStrNum,sVeter);
        b+=6;
        if(tmp<200)
                FToStr1(b,fVeter);
        else
                FToStr(b,cHis[8],1);
        
        b[6]='m';
        b[7]='/';
        b[8]='c';
        break;


        case    112:                    //  - 
        CopyStrFlash(cStrNum,sVl);     //
        b+=9; 
        *(b++)='C';
        b++;
        fSVl=((float)ueSVl)/1000.;
        UToStr(b,ueSVl);
        break;
        
        case    113:                
        CopyStrFlash(cStrNum,sVl);     //-
        fKVl=((float)ueKVl)/10000.;
        b+=9; 
        *(b++)='K';
        *(b++)='.';
        UToStr(b,ueKVl);
        break;

        case    7:                      //
        case    204:
        CopyStrFlash(cStrNum,sVl);
        b+=9;       
        if(tmp<200)
                FToStr(b,fVl,1);
        else
                FToStr(b,cHis[7],1);
        b[5]='%';
        break;             

        case    8:                      // 
        CopyStrFlash(cStrNum,sFL);
        b+=10;
        cFL=FL(ucTime[3],ucTime[5],uYear);
        if(cFL<0)
                {
                *(b++)='-';
                cFL=-cFL;
                }   
        *(b++)='0';
        *(b++)='.';
        if(cFL>=10)
                {
                *(b++)='0'+cFL/10;
                cFL%=10;
                }         
        *b='0'+cFL;
        break;             

        case    100:                    // - 
        CopyStrFlash(cStrNum,sNastr);
        break;

        case    101:                    // - 
        case    102:                    // - 
        case    103:                    // - 
        case    104:                    // - 
        CopyStrFlash(cStrNum,sParNastr[tmp-101]);
        b+=12;        
        UCToStr(b,ucTime[tmp-101]);
        break;
        
        case    108:                    // - 
        CopyStrFlash(cStrNum,sParNastr[tmp-101]);
        b+=12;        
        UToStr(b,cSecMax);
        break;

        case    105:                    // -  
        CopyStrFlash(cStrNum,sParNastr[tmp-101]);
        b+=8;        
        for(i=0;sDN[ucTime[4]][i];i++)
                *(b++)=sDN[ucTime[4]][i];
        break;

        case    106:                    // - 
        CopyStrFlash(cStrNum,sParNastr[tmp-101]);
        b+=7;        
        for(i=0;sMon[ucTime[5]][i];i++)
                *(b++)=sMon[ucTime[5]][i];
        break;

        case    107:                    // - 
        CopyStrFlash(cStrNum,sParNastr[tmp-101]);
        UToStr(b+10,uYear);
        break;
        
        case    109:                    // - 
        CopyStrFlash(cStrNum,sParNastr[tmp-101]);
        break;

        case    114:                    // -          
        CopyStrFlash(cStrNum,sParNastr[9]);
        break;                
        
        case    115:                    // -   
        CopyStrFlash(cStrNum,sParNastr[10]);
        b+=7;
        if(cFlag&4)
                {
                *(b++)=224;            //
                *(b++)=97;
                }
        else
                {
                *(b++)=72;              //
                *(b++)=101;
                *(b++)=191;
                }
        break;   
        
        case    200:                    //  
        UCToStr(b,cHis[1]);
        b+=2;
        *(b++)='/';
        UCToStr(b,cHis[2]+1);
        b+=2;
        *(b++)='/';
        UToStr(b,2000+cHis[3]);
        b+=4;
        *(b++)=' ';
        UCToStr(b,cHis[0]);
        b+=2;
        *(b++)=':';
        *(b++)='0';
        *(b++)='0';
        break;
                   
        case    150:                    //
        CopyStrFlash(cStrNum,smBud0);
        b+=10;                     
        *b='1'+uBud;
        break;
        
        case    151:                    // 
        UCToStr(b,cBud[uBud][0]);
        b+=2;
        *(b++)=':';
        UCToStr(b,cBud[uBud][1]);
        b+=2;    
        *(b++)=' ';
        *(b++)=' ';
        b1=cBud[uBud][2];   
        for(i=0,j=1;i<7;i++,j<<=1)
                {          
                if(b1&j)
                        *(b++)=smBud1[i];
                else
                        *(b++)=smBud2[i];
                }
        *(b++)=' ';
        if((b1&j))
                *(b++)='D';
        else
                *(b++)='H';
        
        break;
        
        default:
        return;                   
        }
OutStr(cStrNum);
if(tmp==151)
        {                       
        if(cStrNum)                           // 
                WR4(0,0xC0+CurBud());
        else
                WR4(0,0x80+CurBud());
        WR4(0,0x0d);    //  c 
        }
else
        WR4(0,0x0c);    //                         

}       


void    SaveInf(void)
{           
if(cFlag&0x20)
        return;
if(!(cFlag&0x40))
        return;
if(uYear<2006)                                                  
        {
        cFlag&=~0x40;
        return;
        }                  
ucSaveStop++;
if(ucSaveStop>=(MAX_SAVE))
        ucSaveStop-=MAX_SAVE;
if(ucSaveStop==ucSaveStart)
        {
        ucSaveStart++;
        if(ucSaveStart>=(MAX_SAVE))
                ucSaveStart-=MAX_SAVE;
        }                 
ieSaveStart=ucSaveStart;
ieSaveStop=ucSaveStop;
WriteMemoryByte(0,ucTime[2]);
WriteMemoryByte(1,ucTime[3]);
WriteMemoryByte(2,ucTime[5]);
WriteMemoryByte(3,uYear-2000);
WriteMemoryByte(4,FtoChar(fTerm[0]));
WriteMemoryByte(5,FtoChar(fTerm[1]));
WriteMemoryByte(6,FtoChar(fPress-700));
WriteMemoryByte(7,FtoUChar(fVl));     
WriteMemoryByte(8,FtoUChar(fVeter));     
cFlag&=~0x40;
}                

void    SendInf(unsigned char ucKomm)
{
unsigned char    b,b1;
unsigned char  i,j;
int        k,k1,k2;  
int             i1;
char            tmp[8];

#asm("sei");
while(cFlag&0x10)
        #asm("WDR");
switch(ucKomm)
        {      
       
        case    'S':            //

        k=((int)ucSaveStop)-((int)ucSaveStart);
        if(k<0)
                k+=MAX_SAVE;
        putchar(k&0xFF);
        putchar(k>>8);
        
        for(k=ucSaveStart,k1=ucSaveStop;k!=k1;k++)
                { 
                k2=k+1;
                if(k2>=(MAX_SAVE))
                        k2-=MAX_SAVE;
                if(k>=(MAX_SAVE))
                        k-=MAX_SAVE;
                for(i=0,b1=0;i<KOL_SAVE1;i++)
                        {
                        ReadMemoryByte(k2,i,&b); 
                        putchar(b);
                        b1+=b;
                        }
                putchar(b1);
                
                }
        break;
        
        case    'O':            // 

        k=ucPointStop-ucPointStart;
        if(k<0)
                k+=KOL_SAVE2;
        putchar(k&0xFF);
        putchar(k>>8);
        
        for(k=ucPointStart,k1=ucPointStop;k!=k1;k++)
                { 
                k2=k+1;
                if(k2>=(KOL_SAVE2))
                        k2-=KOL_SAVE2;
                if(k>=(KOL_SAVE2))
                        k-=KOL_SAVE2;
                for(i=0,b1=0;i<5;i++)
                        {
                        b=ecPoint[k2][i];; 
                        putchar(b);
                        b1+=b;
                        }
                putchar(b1);
                
                }
        break;


        case    'C':            //
        ucSaveStart=ucSaveStop;
        ieSaveStart=ucSaveStart;
        break;           

        case    'c':            //
        ucPointStart=ucPointStop;
        iePointStart=ucPointStart;
        break;           
        
        case    'P':            // 
        while(tx_counter)
                #asm("WDR");
        i1=fTerm[0]*10;
        putchar(i1&0xFF);  
        putchar(i1>>8);
        while(tx_counter)
                #asm("WDR");
        i1=fTerm[1]*10;
        putchar(i1&0xFF);  
        putchar(i1>>8);
        while(tx_counter)
                #asm("WDR");
        i1=fPress;
        putchar(i1&0xFF);  
        putchar(i1>>8);
        while(tx_counter)
                #asm("WDR");
        i1=fVl*10;
        putchar(i1&0xFF);  
        putchar(i1>>8);
        while(tx_counter)
                #asm("WDR");
        i1=fVeter*10;
        putchar(i1&0xFF);  
        putchar(i1>>8);
        break;
        
        case    'T':            // 
        for(i=0;i<7;i++)
                {           
                #asm("WDR");
                for(i1=0;i1<20000;i1++)
                        if(rx_counter)
                                break;
                if(!rx_counter)
                        break;
                tmp[i]=getchar();
                }
        if(i!=7)
                break;
        for(i=0;i<6;i++)
                ucTime[i]=tmp[i];
        uYear=2000+tmp[i];
        break;                
        

        case    'V':            //
        while(tx_counter)
                #asm("WDR");
        i=41;                   // 
        putchar(i);
        for(j=0;j<i;j++)
                {
                while(tx_counter)
                        #asm("WDR");
                putchar(ucVersion[j]);  
                }
        break;
        
        }
}

                                            
void  ReadMemoryByte(unsigned uAdr,unsigned char uByte,unsigned char *pucByte)
{     
unsigned        u; 
           
u=(uAdr)*KOL_SAVE1+uByte;
MemReadByte(u,pucByte);
} 


void    WriteMemoryByte(unsigned char uByte,unsigned char ucByte)
{  
unsigned        u;

u=(ucSaveStop)*KOL_SAVE1+uByte;
MemWriteByte(u,ucByte);
}
#include        "termD.h"
#include        <ds18b20.h>

extern unsigned char ds1820_devices;
extern unsigned char ds1820_rom_codes[2][9];
extern float   fTerm[2];  
extern unsigned char cFlag;            
extern float   fPress;
extern int iPress0;    
extern unsigned uKPress;
extern unsigned uPress,uVl;
char    cIsTemp[2]={0,0};
extern  eeprom  char            ds1820_rom_codes_e[2][9];
extern  eeprom  char            cIsTemp_e[2];
                                                   

void    LoadDS(void)
{
char    i;                    
char *t;
eeprom  char *s;

s=ds1820_rom_codes_e[0];
t=ds1820_rom_codes[0];
for(i=0;i<18;i++,t++,s++)
        *(t)=*(s);
cIsTemp[0]=cIsTemp_e[0];
cIsTemp[1]=cIsTemp_e[1];
}

void    SaveDS(void)
{
char    i;                    
char *t;
eeprom  char *s;

s=ds1820_rom_codes_e[0];
t=ds1820_rom_codes[0];
for(i=0;i<18;i++,t++,s++)
        *(s)=*(t);
cIsTemp_e[0]=cIsTemp[0];
cIsTemp_e[1]=cIsTemp[1];
}

void    CopyDS(char *t,char *s)
{                             
char    i;

for(i=0;i<9;i++,t++,s++)
        *(t)=*(s);
}
                    
void    ObmenDS(void)
{
char    tmp[10],i;

CopyDS(tmp,ds1820_rom_codes[0]);
CopyDS(ds1820_rom_codes[0],ds1820_rom_codes[1]);
CopyDS(ds1820_rom_codes[1],tmp);   
i=cIsTemp[0];
cIsTemp[0]=cIsTemp[1];
cIsTemp[1]=i;
SaveDS();
}

void            FindTemp(void)
{
unsigned char i;


for(i=0;i<5;i++)
       {
       ds1820_devices=w1_search(0xf0,ds1820_rom_codes);
       #asm("WDR");   
       if(ds1820_devices)
               {
               if(ds1820_devices>=2)
                       ds1820_devices=2;
               break;
               }
       }
for(i=0;i<2;i++)
        {
        cIsTemp[i]=0;
        }
for(i=0;i<ds1820_devices;i++)
       {
       ds18b20_init(&ds1820_rom_codes[i][0],20,30,DS18B20_12BIT_RES);
       cIsTemp[i]=1;
       }                                                               
}

void            IzmTemp(void)
{
unsigned char i;    
signed int      iT;  
float           f;

for(i=0;(i<2);i++)
        {     
       if(!cIsTemp[i])        
                {
                fTerm[i]=10000;                                   
                continue;
                }
        w1_init();
        ds18b20_read_spd(ds1820_rom_codes[i]);
        if(w1_dow_crc8(&__ds18b20_scratch_pad,8)==__ds18b20_scratch_pad.crc)
                {
                iT=(((int)__ds18b20_scratch_pad.temp_msb)<<8)| __ds18b20_scratch_pad.temp_lsb;
                f=((float)iT)/16;
                if((f>-50.)&&(f<70))
                        fTerm[i]=f;     
                }
        else
                fTerm[i]=10000;
        }       
w1_init();
w1_write(0xCC);
w1_write(0x44);   
}         

void            IzmPress(void)
{
uPress=read_adc(7);         
}   

void            IzmVl(void)
{
uVl=read_adc(6);         
}   

#include        "mem_srv.h"

#asm
    .equ __i2c_port=0x18     ;//PORTB
    .equ __sda_bit=6
    .equ __scl_bit=7
#endasm

#include <i2c.h>
#define EEPROM_BUS_ADDRESS 0xa0


void    MemInit(void)
{
return;
i2c_init();
}

void    MemReadByte(unsigned uAdr,unsigned char *b)
{
unsigned char data;

i2c_start();
i2c_write(EEPROM_BUS_ADDRESS);
i2c_write(uAdr>>8);
i2c_write(uAdr);
i2c_start();
i2c_write(EEPROM_BUS_ADDRESS|1);
data=i2c_read(0);
i2c_stop();
*b=data;
}
 

void    MemWriteByte(unsigned uAdr,unsigned char b)
{
i2c_start();
i2c_write(EEPROM_BUS_ADDRESS);
i2c_write(uAdr>>8);
i2c_write(uAdr);
i2c_write(b);
i2c_stop();
delay_ms(10);
}

           
#include	"bud.h"
#include	"serv.h"

extern  unsigned char uBud,ucCurBud;
extern eeprom  unsigned char ucBud[KOL_BUD1][3];       //0 - 
                                                //1 - 
                                                //2 -   ()
extern unsigned char cBud[KOL_BUD1][3];
       
extern unsigned char   ucPointStart,ucPointStop;
extern eeprom  unsigned char     iePointStart,iePointStop; 
extern eeprom  unsigned char ecPoint[KOL_SAVE2][5];

void    LoadBud(void)
{
char    i;

for(i=0;i<KOL_BUD1;i++)
        {
        cBud[i][0]=ucBud[i][0];
        cBud[i][1]=ucBud[i][1];
        cBud[i][2]=ucBud[i][2];
        }
}

void    SaveBud(unsigned char n)
{
ucBud[n][0]=cBud[n][0];
ucBud[n][1]=cBud[n][1];
ucBud[n][2]=cBud[n][2];
}

unsigned char CurBud(void)
{
static  unsigned char c[]={1,4,7,8,9,10,11,12,13,15};                    //    

return c[ucCurBud];
}

void    ControlBud(void)
{
unsigned char   uc=1,tmp;                                                  
unsigned char cOutOld[2];

cOutOld[0]=cOut[0];
cOutOld[1]=cOut[1];

cOut[0]=150;                    // ""
OutInd(0);
cOut[1]=151;                    
while(9)
        {
        #asm("WDR"); 
        if(uc)
                {
                uc=0;
                OutInd(1);
                } 
        SaveInf();  
        Idle();
        while(rx_counter)
                {
                tmp=getchar();
                #asm("nop");
                #asm("nop");
                #asm("nop"); 
                SendInf(tmp);
                }
        tmp=GetKey();
        if(!tmp)        
                continue;
        TBeep(64,8,kKey);
        switch(tmp)
                {       
                case    0b1000:         //<-Up               
                SaveBud(uBud);
                uBud++;
                if(uBud>=KOL_BUD1)
                        uBud=0;
                ucCurBud=0;
                uc=1;      
                OutInd(0);
                continue;                                 
        
                case    0b1001:         //<-Down
                if(ucCurBud)
                        ucCurBud--;
                else
                        ucCurBud=9;
                uc=1;
                continue;                                 
        
                case    0x0F:         //
                SaveBud(uBud);
                break;
        
                case    0b0100:         //-> Up     
                if(ucCurBud==0)
                        {
                        cBud[uBud][0]++;
                        if(cBud[uBud][0]>23)
                                cBud[uBud][0]=0;
                        }
                else if(ucCurBud==1)
                        {
                        cBud[uBud][1]++;
                        if(cBud[uBud][1]>59)
                                cBud[uBud][1]=0;
                        }              
                else
                        {
                        tmp=1<<ucCurBud-2; 
                        cBud[uBud][2]^=tmp;
                        }
                uc=1;
                continue;                                 
        
                case    0b0101:         //->Down    (-1)
                ucCurBud++;
                if(ucCurBud>9)
                        ucCurBud=0;
                uc=1;
                continue;                                 
        
                default:                // 
                continue;
                }
        break;
        }
         
cOut[0]=cOutOld[0];
cOut[1]=cOutOld[1];
OutInd(0);
OutInd(1);
}                         

void    TstBud(void)
{
char    i;
unsigned char c;

for(i=0;i<KOL_BUD1;i++)
        {    
        c=cBud[i][0];
        c=cBud[i][1];
        c=cBud[i][2];
        if(!(c&0x80))
                continue;
        c=cBud[i][0];
        if(c!=ucTime[2])
                continue;
        if(cBud[i][1]!=ucTime[1])
                continue;   
        if(!(cBud[i][2]&(1<<ucTime[4])))
                continue;
        OCR1A=100;
        TCCR1A=0x40;
        cFlag|=2;
        }
}            

void    AddPoint(void)
{
if(uYear<2006)                                                  
        {
        cFlag&=~0x40;
        return;
        }                  
ucPointStop++;
if(ucPointStop>=(KOL_SAVE2))
        ucPointStop-=KOL_SAVE2;
if(ucPointStop==ucPointStart)
        {
        ucPointStart++;
        if(ucPointStart>=(KOL_SAVE2))
                ucPointStart-=KOL_SAVE2;
        }                 
iePointStart=ucPointStart;
iePointStop=ucPointStop;
ecPoint[ucPointStop][0]=ucTime[1];
ecPoint[ucPointStop][1]=ucTime[2];
ecPoint[ucPointStop][2]=ucTime[3];
ecPoint[ucPointStop][3]=ucTime[5];
ecPoint[ucPointStop][4]=uYear-2000;
}
